=== tests/adc1/CMakeLists.txt ===
include(TestingMacros)

add_regression_test(adc1 "psi;adc")
