=== tests/ao-dfcasscf-sp/CMakeLists.txt ===
include(TestingMacros)

add_regression_test(ao-dfcasscf-sp "psi;quicktests;casscf")
