=== debian/changelog ===
psi4 (1:1.3.2+dfsg-6) unstable; urgency=medium

  * debian/control (Build-Depends): Added python3-setuptools.
  * debian/control (Build-Depends): Require python3-qcelemental 0.29.0-2 or
    above (Closes: #1093352).
  * debian/control (psi4/Depends): Added python3-pint.

 -- Michael Banck <mbanck@debian.org>  Sun, 16 Mar 2025 23:23:59 +0100

psi4 (1:1.3.2+dfsg-5) unstable; urgency=medium

  * debian/patches/numpy-1.24.patch: New patch, fixes runtime errors with
    numpy-1.24, partly taken from upstream commits 7398292 and f5b7cf9 (Closes:
    #1027216).

 -- Michael Banck <mbanck@debian.org>  Sun, 29 Jan 2023 23:46:37 +0100

psi4 (1:1.3.2+dfsg-4) unstable; urgency=medium

  [ James Addison ]
  * debian/patches/cmake_pymodulesuffix.patch: New patch, fixes runtime errors
    with Python 3.11 (Closes: #1027025).

  [ Michael Banck ]
  * debian/watch: Updated. 

 -- Michael Banck <mbanck@debian.org>  Sat, 07 Jan 2023 19:13:25 +0100

psi4 (1:1.3.2+dfsg-3) unstable; urgency=medium

  * debian/patches/gcc12_compile_fix.patch: New patch, fixes a build error with
    gcc-12, taken from upstream commit 3ed26f7b (Closes: #1013017).

 -- Michael Banck <mbanck@debian.org>  Fri, 04 Nov 2022 17:31:27 +0100

psi4 (1:1.3.2+dfsg-2.1) unstable; urgency=medium

  * Point dh_python3 at the installed Python extension (Closes: #1004907).

 -- Stefano Rivera <stefanor@debian.org>  Sat, 26 Mar 2022 08:31:19 -0400

psi4 (1:1.3.2+dfsg-2) unstable; urgency=medium

  * Tighten dependencies on libint (Closes: #983481)

 -- Graham Inggs <ginggs@debian.org>  Thu, 04 Mar 2021 11:31:06 +0000

psi4 (1:1.3.2+dfsg-1) unstable; urgency=medium

  * Team upload.
  * Remove binary without source from upstream tarball
  * Fix some issues recent Python3 is more picky than before
    Closes: #982171
  * Do not ship __pycache__ dirs as leftovers from build time test
  * Fix path to bash
  * Simplify backports
  * Drop unnecessary default dh-argument --parallel
  * Fix spelling of Python in long description

 -- Andreas Tille <tille@debian.org>  Fri, 19 Feb 2021 14:52:51 +0100
