=== debian/watch ===
version=3
opts="repacksuffix=+dfsg,dversionmangle=auto,repack,compression=xz,uversionmangle=s/(rc\d*)$/~$1/g" \
   https://github.com/psi4/psi4/tags .*/v([\d.]+(?:rc\d*)?)\.tar\.gz
